#!/usr/perl5/bin/perl -w
#
# Copyright (c) 2001 by Sun Microsystems, Inc.
# All rights reserved.
#
#ident	"@(#)cancel.pl	1.3	01/07/27 SMI"
#
# Installation cancel page

require 5.005;
use strict;
use lib '/opt/SUNWscvw/lib/perl';
use Cluster::Cgi;
use Cluster::Install;
use Sun::Solaris::Utils qw(gettext);

# Create the html query object
my $q = new Cluster::Cgi;

# Create a install object
my $install = new Cluster::Install;

# Start the html document
$install->header($q, [gettext("Sun Cluster Installation"),
    "/cgi-bin/installation/step0.pl",
    gettext("Cancel Installation")]);
print $q->p({class => "action-window-normal-text"});

print $q->start_form({ action => '/cgi-bin/installation/step0.pl',
			method => 'get'
			});

$install->start_message_table($q, "/images/warning_32.gif", "Warning",
			gettext("Confirm Cancel"),
			gettext("To cancel the installation without " .
			  "configuring the cluster, click Cancel " .
			  "Installation. Otherwise, return " .
			  "to the installation process by clicking Back."));
$install->end_message_table($q);

$install->start_button_table($q);
print $q->input({	TYPE => "button",
			VALUE => gettext("  < Back  "),
			ONCLICK => "history.back()",
			NAME => "back",
			});
print "&nbsp;\n";

print $q->input({	TYPE => "submit",
			VALUE => gettext("  Cancel Installation  "),
			NAME => "cancel",
			});


$install->end_button_table($q);
		
print $q->end_form();

# End the html document
$install->footer($q);
