#!/usr/perl5/bin/perl
#
# Copyright (c) 2001 by Sun Microsystems, Inc.
# All rights reserved.
#
#pragma ident   "@(#)check_metadb.pl 1.3     01/08/15 SMI"
#
# Find out if all of the nodes have created their metadb replicas

require 5.005;
use lib '/opt/SUNWscvw/lib/perl';
use Cluster::Install;

# Create a install object
my $install = new Cluster::Install;

# Get the size of the cluster, and the list of nodes
my $file = '/var/cluster/spm/nodelist';

open(FILE, $file);
my $nodelist = <FILE>;
chomp $nodelist;
close(FILE);

my @nodelist = split /,/, $nodelist;
my $metadb_count = 0;

# Contact each node to make sure it has created its metadb replica
foreach my $node (@nodelist) {
    my ($does_metadb_exist, $location);
    $location = "/cgi-bin/installation/check_metadb_local.pl";
    ($does_metadb_exist) = $install->get_http($node, $install->get_http_port(),
	$location, undef, 1);
    if (defined $does_metadb_exist) {
        chomp $does_metadb_exist;
        if ($does_metadb_exist eq "YES") {
	     $metadb_count++;
	}
    }
}

# If all nodes have created their metadb replicas, then return 0; otherwise
# return 1.
if ($metadb_count == @nodelist ) {
    exit 0;
} else {
    exit 1;
}
