#!/usr/perl5/bin/perl -w
#
# Copyright 2001-2002 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# ident	"@(#)clustermode_local.pl	1.4	02/03/04 SMI"
#
# Local stub which makes sure the cluster is completely up by checking
# for the existence of the rgmd process.  Also ensure that this node
# is at the setup_sds barrier point.

require 5.005;
use strict;
use lib '/opt/SUNWscvw/lib/perl';
use Cluster::Cgi;

my ($barrier_flag) = "/var/cluster/spm/setup_sds_barrier";

# Create the html query object
my $q = new Cluster::Cgi;

# Print the header
print $q->header();

# Call clinfo
`/usr/bin/pgrep -f /usr/cluster/lib/sc/rgmd`;

# Get result
my $ret = $?;

# Print result
if ($ret == 0 && -e $barrier_flag) {
    print "YES";
    exit 0;
} else {
    print "NO";
    exit 1;
}
