#!/usr/bin/pfksh
#
# Copyright 2001-2002 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# ident	"@(#)installation.ksh	1.15	02/02/22 SMI"
#
# This script will install the SDS pacakges, add any patches, and also
# edit the /kernel/drv/md.conf file. It will then create an rc3 script
# that will recreate several namespaces and then invoke a
# reconfiguration reboot. Input: Solaris 8 cdrom path, SDS patch
# path. Output: Installation of SDS packages on a node. Assumptions:
# Solaris 8 installed, SC3.0 installed, and access to SDS4.2.1
# packages can be given by user.

# Variables
logdir=/var/cluster/spm
cluster_bin_dir=/usr/cluster/bin
rc3_dir=/etc/rc3.d
new_md_conf=/opt/SUNWscvw/cgi-bin/installation/sds/md.conf.new

# Function declarations
function exe_cmd 
{
	# This function executes and then logs any given command
	echo "$*"
	echo "$*" >> ${logdir}/sds_installation.log
	eval $*

	if [ $? -ne 0 ]; then
		echo "Unexpected error in executing command:\t$*\n"
		echo "See ${logdir}/sds_installation.log for details.\n"
		exit 1
	fi
}

# Add the SDS packages to the node if we're on Solaris 8
osversion=`uname -r`
if [ "$osversion" = "5.8" ]
then
    solaris_cdrom_path=$1
    sds_package_location=$solaris_cdrom_path/Solaris_8/EA/products/DiskSuite_4.2.1/sparc/Packages
    pkgadd -a /opt/SUNWscvw/cgi-bin/installation/sds/noask_pkgadd -d $sds_package_location SUNWmdg SUNWmdja SUNWmdnr SUNWmdnu SUNWmdu SUNWmdx SUNWmdr
fi

# Modify the md.conf file so more than 3 metasets can be created
# Save the old md.conf file
exe_cmd mv /kernel/drv/md.conf /kernel/drv/md.conf.orig

# Copy the md.conf that allows the creation of 15 metasets
exe_cmd cp $new_md_conf /kernel/drv/md.conf
exe_cmd chmod 444 /kernel/drv/md.conf
exe_cmd chgrp sys /kernel/drv/md.conf
	
# Do a reconfiguration reboot of this node.
exe_cmd touch /reconfigure
