#!/usr/perl5/bin/perl -w
#
# Copyright (c) 2001 by Sun Microsystems, Inc.
# All rights reserved.
#
#pragma ident   "@(#)menu.pl 1.13     01/07/27 SMI"
#
# Create the Javascript or HTML cluster menu

require 5.005;
use strict;
use lib '/opt/SUNWscvw/lib/perl';
use Cluster::Cgi;
use Cluster::Menu;
use Cluster::Common;
use Sun::Solaris::Utils qw(gettext);

# Create objects
my $q = new Cluster::Cgi;
my $menu = new Cluster::Menu;
my $cluster = new Cluster::Common;

# Set autoflush
$| = 1;

# Set the mode
my $mode = "";
if (defined $q->param("mode")) {
	$mode = $q->param("mode");
}

# Print the CGI header and make the page expire now
print $q->header(-expires => "now");

# Start the document
print $q->start_html({ STYLE  => { 'src' => '/css/clustmgr-style.css'},
		       TITLE    => gettext("MenuTree"),
		       CLASS    => "tree-body",
		       ONRESIZE => "if (document.layers) " .
			           "self.location.reload(true)",
		       });

# Print the correct menu type
if ($mode eq "basic") {

	# Basic HTML menu 
	$menu->getClusterName($q, $mode, $cluster->get_clustername());
	$menu->getNodes($q, $mode);
	$menu->getResourceGroups($q, $mode);
	$menu->getTransports($q, $mode);
	$menu->getGlobalDevices($q, $mode);
	$menu->getQuorum($q, $mode);

} else { 
	# Invisible accessibility link to simplified menu
	print $q->a({href => "/cgi-bin/index.pl?menu=basic", target => "_top"},
		$q->img({src => "/images/dot.gif", width => 1, height => 1,
		    border => 0, align => "right",
		    alt => gettext("Load simplified menu")}));

	# Load the Javascript libraries
	print $q->start_script({ SRC => '/js/menutree.js' });
	print $q->end_script();

	print $q->start_script({ SRC => '/js/browserVersion.js' });
	print $q->end_script();

	# Print the Javascript tree
	print $q->start_script();
	print "USETEXTLINKS = 1\n";
	$menu->getClusterName($q, $mode, $cluster->get_clustername());
	$menu->getNodes($q, $mode);
	$menu->getResourceGroups($q, $mode);
	$menu->getTransports($q, $mode);
	$menu->getGlobalDevices($q, $mode);
	$menu->getQuorum($q, $mode);
	print "initializeDocument()";
	print $q->end_script();
}

# End the document
print $q->end_html;
