#!/usr/perl5/bin/perl -w
#
# Copyright (c) 2001 by Sun Microsystems, Inc.
# All rights reserved.
#
#pragma ident   "@(#)network_config.pl 1.5     01/07/27 SMI"
#
# Network configure page
#

require 5.005;
use strict;
use lib '/opt/SUNWscvw/lib/perl';
use Cluster::Cgi;
use Cluster::Network;
use Sun::Solaris::Utils qw(gettext);

# Create the html query object
my $q = new Cluster::Cgi;

# Create a network object
my $network = new Cluster::Network;

my $node = $q->param('node');
my $adp = $q->param('adp');
my $step = $q->param('step');
my $func = $q->param('func');
my $nafogroup = $q->param('nafogroup');

# Check if in Cluster mode
if ($network->is_clustermode($q) != 0) {
        # not in cluster mode
        $network->print_nonclustermode_error($q);
        exit;
}

# Print the query header
print $q->header();

# Start the document
my $menu_jscript = $q->jump_menu_jscript();
my $network_jscript = $network->network_jscript();
my $jscript = $menu_jscript . "\n" . $network_jscript .
    $q->yoke_jscript("nf-$node");
print $q->start_html({  TITLE => gettext("Configure Network"),
			STYLE  => { 'src' => '/css/clustmgr-style.css'},
                        CLASS  => "default-body",
                        SCRIPT => $jscript
                        });

SWITCH: {
	if ($func eq "Add") {
		$network->add_adapter($q, $step, $node, $nafogroup, $adp);
		last SWITCH;
	}
	if ($func eq "Remove") {
		$network->remove_adapter($q, $step, $node, $nafogroup, $adp);
		last SWITCH;
	}
	if ($func eq "Switch") {
		$network->switch_adapter($q, $step, $node, $nafogroup, $adp);
		last SWITCH;
	}
	if ($func eq "Create") {
		$network->create_nafogroup($q, $step, $node, $nafogroup, $adp);
		last SWITCH;
	}
	if ($func eq "Delete") {
		$network->delete_nafogroup($q, $step, $node, $nafogroup);
		last SWITCH;
	}
}

# End the html document
$network->footer($q);
